using System;
using System.Collections.Generic;
using Stun2DPhysics4SL.Dynamics;
using Stun2DPhysics4SL.Mathematics;

namespace Stun2DPhysics4SL
{
    public class PhysicsSimulator
    {
        /// <summary>
        /// Bodyļ
        /// </summary>
        private List<Body> bodyAddList;

        /// <summary>
        /// Ϊfalseϵͳֹͣ
        /// </summary>
        public bool Enabled = true;

        /// <summary>
        /// BodyϵٶȣĬΪ9.8
        /// </summary>
        public Vector2 Gravity = new Vector2(0, 9.8f);

        /// <summary>
        /// һ<see cref="PhysicsSimulator"/>
        /// </summary>
        public PhysicsSimulator()
        {
            ConstructPhysicsSimulator();
        }

        private void ConstructPhysicsSimulator()
        {
            bodyAddList = new List<Body>(32);
        }

        /// <summary>
        /// ڼһBody
        /// </summary>
        /// <param name="body"></param>
        public void Add(Body body)
        {
            if (body == null)
                throw new ArgumentNullException("body", "bodyΪnull");

            if (!bodyAddList.Contains(body))
            {
                bodyAddList.Add(body);
            }
        }

        /// <summary>
        /// ϵͳ
        /// </summary>
        /// <param name="dt">ʱ</param>
        public void Update(float dt)
        {
            // ʱΪ0ϵͳûм򲻽κβ
            if (dt == 0 || !Enabled)
                return;

            ApplyForces(dt);
            UpdatePositions(dt);
        }

        /// <summary>
        /// Bodyλá
        /// </summary>
        /// <param name="dt">ʱ</param>
        private void UpdatePositions(float dt)
        {
            for (int i = 0; i < bodyAddList.Count; i++)
            {
                if (bodyAddList[i].isStatic)
                    continue;

                bodyAddList[i].IntegrateVelocity(dt);
                bodyAddList[i].IntegratePosition(dt);
            }
        }

        /// <summary>
        /// Bodyʩ
        /// </summary>
        /// <param name="dt">ʱ</param>
        private void ApplyForces(float dt)
        {
            for (int i = 0; i < bodyAddList.Count; i++)
            {
                Body body = bodyAddList[i];
                if (body.isStatic)
                    continue;

                if (!body.IgnoreGravity)
                {
                    body.force.X = body.force.X + (Gravity.X * body.mass);
                    body.force.Y = body.force.Y + (Gravity.Y * body.mass);
                }

                body.IntegrateVelocity(dt);
                body.ClearForce();
            }
        }
    }
}